library IEEE;
use IEEE.STD_LOGIC_1164.ALL;     -- Fuer std_logic und std_logic_vector
use IEEE.NUMERIC_STD.ALL;        -- Fuer signed und unsigned Datentypen

entity DataTypesExample is
    port (
        input_slv : in std_logic_vector(7 downto 0);        -- std_logic_vector Eingang
        output_slv_calc : out std_logic_vector(7 downto 0); -- std_logic_vector Ausgang (Ergebnis einer Berechnuung)
        output_slv_mask : out std_logic_vector(7 downto 0); -- std_logic_vector Ausgang (Ergebnis einer Maksierung)
        output_slv_set : out std_logic_vector(7 downto 0)   -- std_logic_vector Ausgang (Setzvorgang)
    );
end DataTypesExample;

architecture Behavioral of DataTypesExample is
    -- constant/signal Deklarationen

    --Legen Sie ein Konstante DataWidth als integer mit Wert 8 an

    --Legen Sie ein Konstante on als std_logic mit 1 an

    --Legen Sie ein Konstante mask als std_logic_vector mit 5Ah an

    --Legen Sie ein signal internal_int als integer mit Wertebreich -128 to 127 an

    --Legen Sie ein signal internal_int als integer mit Wertebreich -128 to 127 an

    --Legen Sie ein signal internal_slv als std_logic_vector mit Laenge 8 an

    --Legen Sie ein signal internal_s als signed mit Laenge 8 an


begin

   -- Maskieren (UND) Sie den Eingang input_slv mit der Maske mask und weisen Sie den Wert dem Ausgang output_slv_mask zu

   -- Der Wert des Ausgangs output_slv_set soll dem Eingang input_slv entsprechen wobei immer das 5 Bit (von 8 Bit) per Bitverkettung gesetzt sein soll
   -- Koonstante one kann verwendet werden

   -- Weisen Sie dem signal internal_slv dein Eingang input_slv zu

   -- Weisen Sie dem signal internal_int das Signal internal_slv zu (Datentypen beachten Konvetierung noetig, mit Vorzeichen)

   -- Rechnen Sie die Subtraktion internal_int - der Konstante eight und weisen Sie das Ergebnis internal_int2 zu

   -- Weisen Sie dem signal das Signal internal_int2 zu (Datentypen beachten Konvetierung noetig)

   -- Weisen Sie dem Ausgang output_slv_calc das signal internal_s zu (Datentypen beachten Konvetierung noetig)

end Behavioral;
